use strict;
use warnings;
use utf8;
use Encode qw(from_to encode decode is_utf8 encode_utf8);
use Encode::Guess qw/shift-jis euc-jp 7bit-jis/;
use LWP::Simple;
# -----------------------------------------------------------------------------
my (@ini,@meigara_code1);
my ($ver,$f_ini_u,$meigara_code,$meigara,$kabu_su,$tanka);
my (%meigara,%kabu_su,%tanka);
    $ver      = "070";
    $f_ini_u  = "_perl_stock_table_utf8_v" . $ver . ".ini";
    if(open(INI,"< $f_ini_u") ) {
      while(<INI>) {
        next if /^#/;
        next if /^ *$/;
        chomp;
        s/ +//g;
    my  $ini = decode("utf-8",$_);
        push(@ini,$ini);
      }
    }
    else {print encode("shift-jis","[$f_ini_u]が見当たりません。！終了します！");<stdin>;exit;}
    print encode("shift-jis","設定ファイルを読み込みました。\n");
# open out_file ---------------------------------------------------------------
my (@time);
my ($time);
    @time     = localtime(time); #作成日付
    @time     = reverse(@time);
    $time[3] += 1900;
    $time[4] += 1;
    $time     = sprintf("%4s%02s%02s_%02s%02s%02s_",@time[3..8]) ;
my  $out_file = "$time" . "stock_table_utf8_v" . $ver . ".html";
    open(OU,"> $out_file");
# -----------------------------------------------------------------------------
    &header;
    # body ------------------
   # test 'http://stocks.finance.yahoo.co.jp/stocks/detail/?code=6758.T';
my  $u1 = 'http://stocks.finance.yahoo.co.jp/stocks/detail/?code=';
my  $u3 = '';
    # body ------------------
my  @meigara_code2 = ('','.o','.t','.q','.n','.f');
my ($jisseki_total);
    for my $ini (@ini) {
      my @ini_evry = split(":",$ini);
      for my $u202 (@meigara_code2 ) {
        my  $u2    = $ini_evry[0] . $u202;
        my  $url   = "$u1$u2$u3";
        my  $l_u   =  get($url);
        if($l_u ne "") {
          &body1($l_u,$u2,@ini_evry);
          $l_u      = "";
          last;
        }
      }
    }
    &body_futterr($jisseki_total);
    #   body end ----------------
    &futer;
    # -------------------------
    close(OU);
    system("start $out_file");
# ===========================================================================
# sub                                                                       =
# ===========================================================================
# body begin -------------------------------------------------------------------------------------
sub body1 {
  my ($l,$u2,@ini_evry) = @_;
  my ($date,$hour,$time_g,$code,$name,$value,$sa,$hi);
      if($l =~ s#<p>現在の日時：<strong>(.+) +(\d+:\d+)</strong>## )              {($date,$time_g) = ($1,$2);}
      if($l =~ s#<title>(.+)【(\w+)】：株式/株価 - Yahoo!ファイナンス</title>##)  {($name,$code)   = ($1,$2);}
      if($l =~ s#<td class="stoksPrice">([\.,\d]+)</td>##          )              {$value          =  $1;    $value =~ s/,+//g;}
      if($l =~ s#<span class="ico.+ yjMSt">(.+)（(.+%)）</span>##  )              {($sa,$hi)       = ($1,$2);$sa    =~ s/,+//g;}
      else                                                                        {$sa = 0;$hi = 0;}
  my  $u22  =   $u2;
      $u22  =~  s/\.\w+//;
      print encode("shift-jis","[$ini_evry[0]]:[$ini_evry[1]]を処理中\n");# <stdin>;
      $name = $ini_evry[1];$kabu_su = $ini_evry[2];$tanka = $ini_evry[3];
      &body2        ($u2);
      &body_up_down ($sa    ,$name          );
      &body21       ($date  ,$time_g,$value );
      &body_mark    ($sa    ,$hi            );
      &body_jisseki ($value ,$tanka,$kabu_su);
      &body3        ($u2    ,$u22           );
}
# ---------------------------------------------------------------------
sub body2 {
my ($u2) = @_;

my  $body2 = << "EOF";
<tr align=right>
<tr align=right>
<td nowrap align=left><a href=http://stocks.finance.yahoo.co.jp/stocks/detail/?code=$u2>$u2</a></td>
EOF
   print OU encode("utf-8",$body2);
}
#
# ---------------------------------------------------------------------
sub body_up_down {
my ($sa,$name) = @_;
    if($sa =~ /\+/){print OU encode("utf-8","<td nowrap align=left><small><img src=http://i.yimg.jp/images/finance/institutional/arrow_up_bl.gif alt=アップ width=20 height=15 align=absmiddle><b>$name&nbsp;</b></small></td>\n");}
    else           {print OU encode("utf-8","<td nowrap align=left><small><img src=http://i.yimg.jp/images/finance/institutional/arrow_down.gif  alt=ダウン width=20 height=15 align=absmiddle><b>$name&nbsp;</b></small></td>\n");}
}
sub body21 {
my ($date,$time_g,$value) = @_;

my  $body21 = << "EOF";

<td nowrap align=center>$date</td>
<td nowrap align=center>$time_g</td>
<td nowrap align=center>$value</td>

EOF
  print OU encode("utf-8",$body21);
}
# ---------------------------------------------------------------------
sub body_mark {
my ($sa,$hi) = @_;
    if($sa =~ /\+/) {print OU "<td nowrap><font color=ff0020>$sa</font></td>\n";print OU "<td nowrap><font color=ff0020>$hi</font></td>\n";}
    else            {print OU "<td nowrap align=center>$sa</td>\n";             print OU "<td nowrap>$hi</td>\n";}
}
# ---------------------------------------------------------------------
sub body_jisseki {
my ($value,$tanka,$kabu_su) = @_;

my  $jisseki;                             # print "jisseki($value,$tanka,$kabu_su)";<stdin>;
    if($tanka == 0) {$jisseki = 0;}
    else            {$jisseki = ($value - $tanka ) * $kabu_su;}
    print OU "<td nowrap align=center>$kabu_su</td>\n";
    print OU "<td nowrap>$tanka</td>\n";
    if($jisseki > 0 ) {print OU "<td nowrap><font color=ff0020>$jisseki</font></td>\n";}
    else              {print OU "<td nowrap>                   $jisseki       </td>\n";}
    $jisseki_total += $jisseki;
}
# ---------------------------------------------------------------------
sub body3 {
my ($u2,$u22) = @_;

my  $body3 = << "EOF";

<td align=left>
<div style=margin:-2px 0;>
<nobr>
<a href=http://stocks.finance.yahoo.co.jp/stocks/detail/?code=$u2>                  <img src=http://i.yimg.jp/images/finance/quote/chart_icon019on.gif  alt=詳細情報                    class=charticon2></a>
<a href=http://stocks.finance.yahoo.co.jp/stocks/chart/?code=$u2>                   <img src=http://i.yimg.jp/images/finance/quote/chart_icon001on.gif  alt=チャート                    class=charticon2></a>
<a href=http://stocks.finance.yahoo.co.jp/stocks/history/?code=$u2>                 <img src=http://i.yimg.jp/images/finance/quote/chart_icon002on.gif  alt=時系列データ                class=charticon2></a>
<a href=http://stocks.finance.yahoo.co.jp/stocks/news/?code=$u2>                    <img src=http://i.yimg.jp/images/finance/quote/chart_icon003on.gif  alt=ニュース                    class=charticon2></a>
<a href=http://charge.biz.yahoo.co.jp/report/sector33/brand_report/$u22.html>       <img src=http://i.yimg.jp/images/finance/quote/chart_icon005on.gif  alt=アナリストレポート          class=charticon2></a>
</nobr>
<a href=http://kabuyoho.ifis.co.jp/index.php?id=100&action=tp1&sa=report&bcode=$u22><img src=http://i.yimg.jp/images/finance/quote/chart_icon018on.gif  alt=株予報（外部サイト）        class=charticon2></a>
<a href=http://info.finance.yahoo.co.jp/stockholder/detail/?code=$u22>              <img src=http://i.yimg.jp/images/finance/quote/chart_icon004off.gif alt=株主優待                    class=charticon2>
<a href=http://stocks.finance.yahoo.co.jp/stocks/profile/?code=$u2>                 <img src=http://i.yimg.jp/images/finance/quote/chart_icon008on.gif  alt=企業情報                    class=charticon2></a>
<a href=http://minkabu.jp/stock/$u3/pick?order=1&sc_id=4&tc_id=ya0f0001>            <img src=http://i.yimg.jp/images/finance/quote/chart_icon015on.gif  alt=みんなの株式（外部サイト）  class=charticon2></a>
<a href=http://messages.yahoo.co.jp/?action=q&board=$u22>                           <img src=http://i.yimg.jp/images/finance/quote/chart_icon009on.gif  alt=掲示板                      class=charticon2></a>
</div></td></tr></tr>
EOF
  print OU encode("utf-8",$body3);
}
# ---------------------------------------------------------------------
sub body_futterr {
my ($jisseki_total) = @_;

my  $body_futter = << "EOF";
  <tr class=chartbg>
    <th nowrap>コード</th>
    <th nowrap>名称</th>
    <th nowrap>日付</th>
    <th nowrap>時間</th>
    <th nowrap>取引値</th>
    <th nowrap colspan=2>前日比</th>
    <th nowrap>持株数</th>
    <th nowrap><font color=ff0020>実績累計→</font></th>
    <th nowrap><font color=ff0020>$jisseki_total</font></th>
    <th nowrap>備考</th>
  </tr>

EOF
  print OU encode("utf-8",$body_futter);
}
# body end -------------------------------------------------------------------------------------
# heder begin -------------------------------------------------------------------------------------
sub header {

my  $header = << "EOF";
<html>
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
  <title>Yahoo!ファイナンス</title>
</head>
<body marginheight=0 topmargin=0><left>
  <h1>　・perl 株式投資シミュレーション</h1>
<table border=1 cellpadding=3 cellspacing=0>
  <tr class=chartbg>
    <th nowrap>コード</th>
    <th nowrap>名称</th>
    <th nowrap>日付</th>
    <th nowrap>時間</th>
    <th nowrap>取引値</th>
    <th nowrap colspan=2>前日比</th>
    <th nowrap>持株数</th>
    <th nowrap>購入単価</th>
    <th nowrap>実績</th>
    <th nowrap>備考</th>
  </tr>
EOF
  print OU encode("utf-8",$header);
  print     "Header END\n";
}
# ---------------------------------------------------------------------
sub futer {

my  $futer = << "EOF";
    </table>
</body>
</html>
EOF
  print OU encode("utf-8",$futer);
  print     "Futer END\n";
}

